#include <htc.h>
#include "timer.h"
#ifdef XT
	__CONFIG(XT&PWRTEN&WDTDIS);				// config XT
#else
	__CONFIG(0x3ff1);						// config XT
	#define OPTION OPTION_REG
#endif

#define EVENT_CLK_TIME 0
#define EVENT_ON_TIME 1
#define EVENT_OFF_TIME 2

bit GeyserFlag;
char GeyserOffTime[4];
char GeyserOnTime[4];
char CurrentTime[4];



extern void cput(unsigned char c);
extern void scroll(const char *mess, unsigned char ntimes);
extern void display(const char *message);
extern void clrscr(void);
extern char choice(const char *const *menu);
extern char getch(void);
extern interrupt isr(void);
extern void delay(unsigned char time); 
extern char choice(const char *const *fmenu);
extern char	sbuf[15];
extern char	line[13];
extern unsigned char sec, min,hour, pulses;
char state;
const char *const menu1[]={
       "SET TIME",
       "VIEW TIME",
       0};

const char *const menu2[]={
       "CLK TIME",  
       "ON TIME",    
       "OFF TIME",    
       0};     
       
void geyser_state_check();
void do_set_time ();
void display_current_time( );
void do_view_time ();

/*************************************************************************************************************************************************/
/*main()                                                                                                                                         */   
/*************************************************************************************************************************************************/
main()
{
  INTCON=0x20;			    	// TMR0 allowed to interrupt
	OPTION=0x07;				// prescaler 1:128 to TMR0, enable pullup resistors on PORTA
	TRISB=0x00;					// RB7 is input RB6:RB0 are inputs
	TRISA=0x07;					// port A RA2:RA0 input
	pulses=0;
	GIE=1;						// enable all interrputs
	TMR0IE=1;
	RW0_HIGH();	RW1_HIGH();		// hold WR high to prevent writing to display
	TRISA=0x00;
	sec, min,hour, state = 0;   //initialise time at 0
//	CurrentTime = 1200;



	char j;
	clrscr();
	while (1)
	{
			switch (state)                                                                       //testing variable state
			{
				case 0:
					geyser_state_check();
					if (mode()){                                                                 //mode button pressed
						state=1;                                           						 //update state to 1
					}
					display_current_time();                     								 //show current time on display
					break;
				case 1:
					j = choice(menu1);                                       					 //scroll menu1 on display
					if (menu1[j]=="SET TIME"){                              					 //set time option selected from menu1
						do_set_time(); 															 //call set time function 
					break;
					}
					else if(menu1[j]=="VIEW TIME"){                         					 //view time option selected from menu1
						do_view_time();														   	 //call view time function
						break;
					}
					else {
						state=0;                                                           		 //update state to zero
					}
					break;
			}
		
	}
}	

/*************************************************************************************************************************************************/
/*void geyser_state_check()                                                                                                                      */
/*This routine determines the state of the geyser by comparing its set on or off times with the system clock                                                                                                                                               */   
/*************************************************************************************************************************************************/
void geyser_state_check(){           //geyser state check function definition

	
	if(GeyserFlag){                                                                             //Flag is on: ie Geyser is on
	
		if(strcmp(GeyserOffTime, CurrentTime) == 0);                                            //GeyserOffTime and CurrentTime are the same
			{
				GeyserFlag = 0;                                                                 //switch the geyser off
				relayoff();
			}                                                                                   //end if
			
	}                                                                                           //end if
	
	else
	{                                                                                            //if Flag is off: ie Geyser is OFF
		if(strcmp(GeyserOnTime, CurrentTime) == 0);                                              //GeyserOnTime and CurrentTime are the same
			{
				relayon();                                                                       //switch the geyser off
				GeyserFlag = 1;                                
	
			}                                                                                    //end if
	}                                                                                            //end else
}

/*************************************************************************************************************************************************/
/*void display_current_time ()                                                                                                                   */
/*This routine updates the clock on the display                                                                                                                                               */   
/*************************************************************************************************************************************************/
void display_current_time()
{
	display(CurrentTime);                                                                         //show current time on display
}	

/*************************************************************************************************************************************************/
/*void do_set_time()                                                                                                                             */
/*                                                                                                                                               */   
/*************************************************************************************************************************************************/
void do_set_time (){

	int event;
	
	event=choice(menu2);                                                                           //scroll menu1 on display
	
		if(event==EVENT_CLK_TIME)                                                                  //clock time option selected from menu2
			{
				scroll("SET CLK",1);
				
		    }
		else if(event==EVENT_ON_TIME)                                                              //on time option selected from menu2     
	
			{
				scroll("SET ON TIME",1);
		    }
		else if(event==EVENT_OFF_TIME)                                                             //off time option selected from menu2  
			{
				scroll("SET OFF TIME",1);
		    }
	}
//}	
//the three parameters will have same code, and what is being pointed to will 
//be executed in the main code.

void do_view_time (){

	scroll("VIEW TIME",1);
}		

/*if ( prev_select_press ) 
  { prev_select_press = 0; rc = Set_time(1);}  // set_TIME hours 
else  
  { prev_select_press = 1; rc = Set_time(0);}  // set_TIME minutes

if ( rc < 0 )   
  { ..............}  // mode changed, no change in time
else
  { ...................}   // time changed, set the time variable, rc is the new time

// call function to re display time

return;
}
***************************************************
//                                                       now you need the function set_time

int Set_time(int hour_min_mode)
{
int new_time = 0;

while (1)
{
   Display_change_time(hour_min_mode, new_time);  // blink the time being changed with the new time
   if ( Set_button_pressed() )  return new_time; 
   if ( Incr_button_pressed() ) { ++new_time; if ( new_time > 59 ) new_time = 0; }
   if ( Select_button_pressed() ) return -1;
  
 }
return 0;
}
*/